'*************************************
'*    GOSOWE ODPALANIE SAMOCHODU    *
'*    wyk. RAFA KUCHTA              *
'*    dj_rav@interia.pl              *
'*    wszelkoie prawa zastrzezone    *
'*                                   *
'*************************************
'
'

$crystal = 4000000
Config Portb = Output
Config Portd = &B0110000
Portd = &B1000010

Config Timer0 = Timer , Prescale = 64                       'Ustawienia Timerw
Config Timer1 = Timer , Prescale = 1
Enable Interrupts
Enable Timer1
On Timer1 Swiatelka
Stop Timer1
Stop Timer0

Dim A As Byte                                               'dekrlarcja zmiennych
Dim B As Byte
Dim C As Byte
Dim D As Byte
Dim E As Byte
Dim F As Byte
Dim H As Byte
Dim I As Byte
Dim L As Byte
Dim M As Byte
Dim R As Byte
Dim P As Byte
Dim S As Word
Dim Zmiana As Byte
Dim Ktora As Byte
Dim Ktory As Byte
Dim Efekt As Byte
Dim Zezwolenie As Byte
Dim Silnik As Byte
Dim X As Bit
Zaplon Alias Portd.5
Zapal Alias Portd.4
S = 1490

Portb = &B00001111                                          'zaswiec wszystkie swiatla
Waitms 255                                                  'odczekaj 255ms
Portb = &B11110000                                          'zgas swiata

If Pind.1 = 0 Then                                          'jesli zostal nacisniety S2 to
   Zezwolenie = 1                                           'wlacz zezwolenie na nagranie sygnalu z nadajnika
Else                                                        'jesli nie byl nacisniety to
   Efekt = 1                                                'wlacz efekt nr1
   Zmiana = 1
End If

Readeeprom E , 5                                            'odczytaj z eepromu kod na jaki ma zareagowac odbiornik
                                                            'glowna petla programu
Do                                                          'jesli jest wlaczony ktorys efekt to
If Efekt > 0 Then                                           'uruchom timer1 odpowiedzialny za dzialanie efektow
   Start Timer1                                             'jesli nie to
Else                                                        'zatrzymaj timer1
   Stop Timer1                                              'wylacz swiatla
   Portb = &B11110000
End If

If Zezwolenie = 0 Then                                      'jesli nacisniety zostal S2 to
   If Pind.6 = 0 Then
L1:
      If Pind.6 = 0 Then                                    'czekaj az go pusci a wtedy
        Goto L1
      End If

      Incr Efekt                                            'zmien efekt
      Incr Zmiana

      If Zmiana = 7 Then
         Zmiana = 0
         Efekt = 0
         S = 1490
      End If

     Waitms 200
   End If
End If

Gosub Pomiar
Loop

Pomiar:
If Pind.0 = 1 Then                                          'sprawdz czy odbiornik cos odbiera a jesli tak to
   Start Timer0
A1:
      If Pind.0 = 1 Then
         If Timer0 > 180 Then Goto C3                       'sprawdz czy jest to sygnal odpowiednio krotki
         Goto A1
      Else
         Stop Timer0
         If Timer0 > 79 Then                                'jesli jest to sygnal startu to
            If Timer0 < 107 Then
B1:
               Incr B
               Timer0 = 0
               Start Timer0
A2:
               If Pind.0 = X Then                           'zaczyna sprawdzac kolejne impulsy
                   If Timer0 > 180 Then Goto C3
                  Goto A2
               Else
                  Stop Timer0
                  If Timer0 > 26 Then                       'jesli impuls jest odpowiednio dlugi to
                     If Zezwolenie = 1 Then                 'sprawdz czy jest wlaczone nagrywanie sygnalu jesli tak to
                     If H > 4 Then
                        If Timer0 > 132 Then                'poczekaj na sygnal stopu o dlugosci 2.5ms +-15%
                           If Timer0 < 180 Then
                              Writeeeprom H , 5             'zapisz do pamieci kod z nadajnika
                              Waitms 10
                              H = 0
                              Portb = &B00001111            'wlacz wszystkie swiatla
                              Wait 10
                              Zezwolenie = 0
                           End If
                        End If
                     End If
                     End If

                     If Timer0 < 36 Then                    'sprawdz czy imuls jest odpowiednio krotki (500us +-15%)
                        Toggle X
                        If Zezwolenie = 1 Then
                           Incr H
                           Goto B1
                        Else
                        If B < E Then Goto B1               'jesli ilosc impulsow nie jest jeszcze rowna tej zapisanej w pamieci to
                        End If                              'sprawdzaj dalej impulsy
                        Timer0 = 0                          ' a jesli tak to
                        Start Timer0
A3:
                        If Pind.0 = 1 Then
                           If Timer0 > 180 Then Goto C3
                           Goto A3
                        Else
                           Stop Timer0
                           If Timer0 > 132 Then             'sprawdz czy nasteny impuls jest impulsem stopu (2.5ms) -tu mozna regulowac margines bledu
                              If Timer0 < 180 Then          'ktory wynosi aktualnie ok +-15%
                                 Incr I
                                 'If I = 5 Then
                                 '   I = 0
                                    If Silnik = 0 Then
                                       Ktory = Efekt        'zapamietaj ustawienia efektow
                                       Ktora = Zmiana
                                    End If

                                    Silnik = 1              'pozwol na odpalenie samochodu
                                    Start Timer1
                                    Zmiana = 1              'wlacz 1 efekt
                                    Efekt = 1
                                 'End If
                              End If
                           End If
                        End If

                     Else
                        Goto C3
                     End If
                  Else
                     Goto C3
                  End If
               End If

            Else
               Goto C3
            End If

         Else
            Goto C3
         End If
      End If

Else
   Goto C3
End If


C3:
B = 0
X = 0
Stop Timer0
Timer0 = 0
Return

Swiatelka:
Timer1 = 45535

If Pind.2 = 1 Then Reset Zapal                              'jesli WE + jest aktywne to wylacz silnik
If Pind.3 = 0 Then Reset Zapal                              'jesli WE - jest aktywne to wylacz silnik

If Zmiana = 6 Then                                          'wlacz szosty efekt czyli
   Incr S
   If S = 1500 Then                                         'co ok.7s
      S = 0
      L = 0
      M = 0
      Incr Efekt                                            'zmieniaj efekt
      If Efekt > 5 Then Efekt = 1                           'od pierwszego do piatego
   End If
End If

If Efekt = 1 Then                                           'pierwszy efekt
   Incr L                                                   'biegnaca fala swietlna
   If L > 6 Then                                            'z lewej do prrawej i z powrotem
      L = 0
      Incr M
      If M > 30 Then M = 0
         Portb = &B11110000
         Portb = Lookup(m , Kit)
   End If
End If

If Efekt = 2 Then                                           'drugi efekt
   Incr P                                                   'dwie fale swietlne zbiegajace sie w srodku
   If P > 1 Then P = 0
   Incr L
   R = M + P
   Portb = &B11110000
   Portb = Lookup(r , Drugi_efekt)
   If L > 8 Then
      L = 0
      M = M + 2
      If M > 27 Then M = 0
   End If
End If

If Efekt = 3 Then                                           'trzeci efekt
   Incr L                                                   'dwie fale swietlne nigdy sie nie zbiegajace
   If L > 8 Then
      L = 0
      Incr M
      If M > 13 Then M = 0
      Portb = &B11110000
      Portb = Lookup(m , Trzeci_efekt)
   End If
End If

   If Efekt = 5 Then                                        'efekt piaty
      Incr L                                                'pelny rozblusk przy pomocy czterek fal swietlnych
         If L > 27 Then
            L = 0
            Incr M
            If M > 7 Then M = 0
            Portb = &B11110000
            'nop
            Portb = Lookup(m , Czwarty_efekt)
         End If
   End If

If Efekt = 4 Then
   Incr P
   If P > 3 Then P = 0
   Incr L
   R = M + P
   Portb = &B11110000
   Portb = Lookup(r , Piaty_efekt)
   If L > 12 Then
      L = 0
      M = M + 4
      If M > 63 Then M = 0
   End If
End If

If Silnik = 1 Then                                          'jesli jest zezwolenie uruchomienia silnika to
   Incr C
   If C = 120 Then                                          'Co Ok 0.6s
      C = 0                                                 'zalacz swiatla oraz zapon
      Set Zaplon
      Incr D
      If D = 3 Then Set Zapal                               'po ok 1.8s wlacz rozrusznik aby zapalic silnik
      If D = 7 Then Reset Zapal                             'a po uplynieciu kolejnych  2.4s wylacz rozrusznik
      If D = 30 Then                                        'po uplynieciu kolejnych 12s
         D = 0                                              'kazde zwiekszenie o 1 zmiennej D powoduje zwiekszenie okreslonego czasu o ok. 0.6s
         Reset Zaplon                                       'Wylacz Swiatla
         Stop Timer1
         Silnik = 0
         Efekt = Ktory                                      'powroc do stanu poczatkowego
         Zmiana = Ktora
         Portb = 0
      End If
   End If
End If

Return

Kit:
Data &B01110001 , &B01110010 , &B01110100 , &B01111000 , &B10110001
Data &B10110010 , &B10110100 , &B10111000 , &B11010001 , &B11010010
Data &B11010100 , &B11011000 , &B11100001 , &B11100010 , &B11100100
Data &B11101000 , &B11100100 , &B11100010 , &B11100001 , &B11011000
Data &B11010100 , &B11010010 , &B11010001 , &B10111000 , &B10110100
Data &B10110010 , &B10110001 , &B01111000 , &B01110100 , &B01110010
Data &B01110001

Drugi_efekt:
Data &B01110001 , &B11101000 , &B01110010 , &B11100100 , &B01110100 , &B11100010
Data &B01111000 , &B11100001 , &B10110001 , &B11011000 , &B10110010 , &B11010100
Data &B10110100 , &B11010010 , &B10111000 , &B11010001 , &B10110100 , &B11010010
Data &B10110010 , &B11010100 , &B10110001 , &B11011000 , &B01111000 , &B11100001
Data &B01110100 , &B11100010 , &B01110010 , &B11100100

Trzeci_efekt:
Data &B01010001 , &B01010010 , &B01010100 , &B01011000 , &B10100001 , &B10100010
Data &B10100100 , &B10101000 , &B10100100 , &B10100010 , &B10100001 , &B01011000
Data &B01010100 , &B01010010

Czwarty_efekt:
Data &B00000001 , &B00000011 , &B00000111 , &B00001111 , &B00001110 , &B00001100
Data &B00001000 , &B00000000

Piaty_efekt:
Data &B10111000 , &B11010001 , 0 , 0 , &B10111100 , &B11010011 , 0 , 0
Data &B10111110 , &B11010111 , 0 , 0 , &B10111111 , &B11011111 , 0 , 0
Data &B10111111 , &B11011111 , &B01111000 , &B11100001 , &B10111111 , &B11011111
Data &B01111100 , &B11100011 , &B10111111 , &B11011111 , &B01111110 , &B11100111
Data &B10111111 , &B11011111 , &B01111111 , &B11101111 , &B10110111 , &B11011110
Data &B01111111 , &B11101111 , &B10110011 , &B11011100 , &B01111111 , &B11101111
Data &B10110001 , &B11011000 , &B01111111 , &B11101111 , &B10110000 , &B11010000
Data &B01111111 , &B11101111 , 0 , 0 , &B01110111 , &B11101110 , 0 , 0
Data &B01110011 , &B11101100 , 0 , 0 , &B01110001 , &B11101000 , 0 , 0
Data &B01110000 , &B11100000